Use this if you want to know how to use the OS.

# Commands

## Disk

Interact with a disk drive. 

Synopsys:

- `disk ls` list all disk drives and its content
- `disk play <drive>` play an audio disk inside a disk drive
- `disk stop <drive>` stops playing audio
- `disk eject <drive>` ejects the disk
- `disk lable <dive> [lable]` Reads or sets a lable on a disk.

## GPS

Interact with the buildin GPS and INS (Inertial Navigation System) system. The INS is used to update a turtle's position when it is moving. 

The GPS has 4 states of accuracy:

- `0` Unknown position
- `1` Position from INS or its best guess
- `2` Position from manual input or the last known position
- `3` Position from GPS

In case of a turtle the GPS accuracy will be set to `1`.

Synopsys:

- `gps set <x> <y> <z>` set the position manually. This will get saved.
- `gps status` prints the current GPS accuracy, position and INS status.
- `gps locate` try to locate the current position. Accuracy will be set to `3` if successful.
- `gps ins` perform an INS alignment. Used to get the current heading.

## KSettings 

Get and set Kernel settings. 

Current settings are:

- `hostname` the hostname of the computer
- `sitecontroller` the id of the site controller

Synopsys:

- `ks get <setting>` print the value of a setting
- `ks set <setting> <value>` set the value of a setting
- `ks list` list all settings

## LSPS

List all processes running on the computer. Very simple and not very useful other than for debugging.

## Net

Interact with the network stack.

Synopsys:

- `net route` print the routing table
- `net iface` list all network interfaces
- `net proto` list all network currently active protocols
- `net ping <id>` ping a remote computer by id

## Peripherals

Interact with the peripherals connected to the computer. 

Synopsys:

- `perf inspect <peripheral>` print all types and methods of a peripheral
- `perf list` list all peripherals

## Redstone

Interact with the redstone. Support for Project Red's Bundle Cable is partialy implemented.

Synopsys:

- `rs on <side> ` turn on redstone on a side
- `rs off <side> ` turn off redstone on a side
- `rs get <side> ` get the redstone state on a side

## Service

Interact with the service manager. A service is a program that runs in the background and can be automatically started when the computer boots.

A service is a normal program. In order to create a new service you must register a command with arguments under a name. 
After that you can start the service by its name. If it is running you can enable it so it will be started when the computer boots.

Synopsys:

- `srv start <name> ` start a service
- `srv stop <name> ` stop a service
- `srv register <name> <binary> [args...]` register a service
- `srv unregister <name> ` unregister a service
- `srv list` list all services
- `srv enable <name> ` enable a service. Must be started before it can be enabled.

## Turtle

Interact with a turtle. Very simple. More to come maybe.

Synopsys:
- `turtle forward` move the turtle forward
- `turtle back` move the turtle back
- `turtle up` move the turtle up
- `turtle down` move the turtle down
- `turtle left` turn the turtle left
- `turtle right` turn the turtle right
